<?php

namespace ArtabanMarketplace\Model\Map;

use ArtabanMarketplace\Model\AmpSeller;
use ArtabanMarketplace\Model\AmpSellerQuery;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\InstancePoolTrait;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\DataFetcher\DataFetcherInterface;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\RelationMap;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Map\TableMapTrait;


/**
 * This class defines the structure of the 'amp_seller' table.
 *
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 */
class AmpSellerTableMap extends TableMap
{
    use InstancePoolTrait;
    use TableMapTrait;
    /**
     * The (dot-path) name of this class
     */
    const CLASS_NAME = 'ArtabanMarketplace.Model.Map.AmpSellerTableMap';

    /**
     * The default database name for this class
     */
    const DATABASE_NAME = 'thelia';

    /**
     * The table name for this class
     */
    const TABLE_NAME = 'amp_seller';

    /**
     * The related Propel class for this table
     */
    const OM_CLASS = '\\ArtabanMarketplace\\Model\\AmpSeller';

    /**
     * A class that can be returned by this tableMap
     */
    const CLASS_DEFAULT = 'ArtabanMarketplace.Model.AmpSeller';

    /**
     * The total number of columns
     */
    const NUM_COLUMNS = 26;

    /**
     * The number of lazy-loaded columns
     */
    const NUM_LAZY_LOAD_COLUMNS = 0;

    /**
     * The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS)
     */
    const NUM_HYDRATE_COLUMNS = 26;

    /**
     * the column name for the ID field
     */
    const ID = 'amp_seller.ID';

    /**
     * the column name for the REF field
     */
    const REF = 'amp_seller.REF';

    /**
     * the column name for the VISIBLE field
     */
    const VISIBLE = 'amp_seller.VISIBLE';

    /**
     * the column name for the ADDRESS1 field
     */
    const ADDRESS1 = 'amp_seller.ADDRESS1';

    /**
     * the column name for the ADDRESS2 field
     */
    const ADDRESS2 = 'amp_seller.ADDRESS2';

    /**
     * the column name for the ADDRESS3 field
     */
    const ADDRESS3 = 'amp_seller.ADDRESS3';

    /**
     * the column name for the ZIPCODE field
     */
    const ZIPCODE = 'amp_seller.ZIPCODE';

    /**
     * the column name for the CITY field
     */
    const CITY = 'amp_seller.CITY';

    /**
     * the column name for the COUNTRY_ID field
     */
    const COUNTRY_ID = 'amp_seller.COUNTRY_ID';

    /**
     * the column name for the EMAIL field
     */
    const EMAIL = 'amp_seller.EMAIL';

    /**
     * the column name for the PHONE field
     */
    const PHONE = 'amp_seller.PHONE';

    /**
     * the column name for the FAX field
     */
    const FAX = 'amp_seller.FAX';

    /**
     * the column name for the URL field
     */
    const URL = 'amp_seller.URL';

    /**
     * the column name for the FACEBOOK field
     */
    const FACEBOOK = 'amp_seller.FACEBOOK';

    /**
     * the column name for the TWITTER field
     */
    const TWITTER = 'amp_seller.TWITTER';

    /**
     * the column name for the PINTEREST field
     */
    const PINTEREST = 'amp_seller.PINTEREST';

    /**
     * the column name for the GOOGLE field
     */
    const GOOGLE = 'amp_seller.GOOGLE';

    /**
     * the column name for the YOUTUBE field
     */
    const YOUTUBE = 'amp_seller.YOUTUBE';

    /**
     * the column name for the INSTAGRAM field
     */
    const INSTAGRAM = 'amp_seller.INSTAGRAM';

    /**
     * the column name for the LATITUDE field
     */
    const LATITUDE = 'amp_seller.LATITUDE';

    /**
     * the column name for the LONGITUDE field
     */
    const LONGITUDE = 'amp_seller.LONGITUDE';

    /**
     * the column name for the CREATED_AT field
     */
    const CREATED_AT = 'amp_seller.CREATED_AT';

    /**
     * the column name for the UPDATED_AT field
     */
    const UPDATED_AT = 'amp_seller.UPDATED_AT';

    /**
     * the column name for the VERSION field
     */
    const VERSION = 'amp_seller.VERSION';

    /**
     * the column name for the VERSION_CREATED_AT field
     */
    const VERSION_CREATED_AT = 'amp_seller.VERSION_CREATED_AT';

    /**
     * the column name for the VERSION_CREATED_BY field
     */
    const VERSION_CREATED_BY = 'amp_seller.VERSION_CREATED_BY';

    /**
     * The default string format for model objects of the related table
     */
    const DEFAULT_STRING_FORMAT = 'YAML';

    // i18n behavior

    /**
     * The default locale to use for translations.
     *
     * @var string
     */
    const DEFAULT_LOCALE = 'en_US';

    /**
     * holds an array of fieldnames
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
     */
    protected static $fieldNames = array (
        self::TYPE_PHPNAME       => array('Id', 'Ref', 'Visible', 'Address1', 'Address2', 'Address3', 'Zipcode', 'City', 'CountryId', 'Email', 'Phone', 'Fax', 'Url', 'Facebook', 'Twitter', 'Pinterest', 'Google', 'Youtube', 'Instagram', 'Latitude', 'Longitude', 'CreatedAt', 'UpdatedAt', 'Version', 'VersionCreatedAt', 'VersionCreatedBy', ),
        self::TYPE_STUDLYPHPNAME => array('id', 'ref', 'visible', 'address1', 'address2', 'address3', 'zipcode', 'city', 'countryId', 'email', 'phone', 'fax', 'url', 'facebook', 'twitter', 'pinterest', 'google', 'youtube', 'instagram', 'latitude', 'longitude', 'createdAt', 'updatedAt', 'version', 'versionCreatedAt', 'versionCreatedBy', ),
        self::TYPE_COLNAME       => array(AmpSellerTableMap::ID, AmpSellerTableMap::REF, AmpSellerTableMap::VISIBLE, AmpSellerTableMap::ADDRESS1, AmpSellerTableMap::ADDRESS2, AmpSellerTableMap::ADDRESS3, AmpSellerTableMap::ZIPCODE, AmpSellerTableMap::CITY, AmpSellerTableMap::COUNTRY_ID, AmpSellerTableMap::EMAIL, AmpSellerTableMap::PHONE, AmpSellerTableMap::FAX, AmpSellerTableMap::URL, AmpSellerTableMap::FACEBOOK, AmpSellerTableMap::TWITTER, AmpSellerTableMap::PINTEREST, AmpSellerTableMap::GOOGLE, AmpSellerTableMap::YOUTUBE, AmpSellerTableMap::INSTAGRAM, AmpSellerTableMap::LATITUDE, AmpSellerTableMap::LONGITUDE, AmpSellerTableMap::CREATED_AT, AmpSellerTableMap::UPDATED_AT, AmpSellerTableMap::VERSION, AmpSellerTableMap::VERSION_CREATED_AT, AmpSellerTableMap::VERSION_CREATED_BY, ),
        self::TYPE_RAW_COLNAME   => array('ID', 'REF', 'VISIBLE', 'ADDRESS1', 'ADDRESS2', 'ADDRESS3', 'ZIPCODE', 'CITY', 'COUNTRY_ID', 'EMAIL', 'PHONE', 'FAX', 'URL', 'FACEBOOK', 'TWITTER', 'PINTEREST', 'GOOGLE', 'YOUTUBE', 'INSTAGRAM', 'LATITUDE', 'LONGITUDE', 'CREATED_AT', 'UPDATED_AT', 'VERSION', 'VERSION_CREATED_AT', 'VERSION_CREATED_BY', ),
        self::TYPE_FIELDNAME     => array('id', 'ref', 'visible', 'address1', 'address2', 'address3', 'zipcode', 'city', 'country_id', 'email', 'phone', 'fax', 'url', 'facebook', 'twitter', 'pinterest', 'google', 'youtube', 'instagram', 'latitude', 'longitude', 'created_at', 'updated_at', 'version', 'version_created_at', 'version_created_by', ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, )
    );

    /**
     * holds an array of keys for quick access to the fieldnames array
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldKeys[self::TYPE_PHPNAME]['Id'] = 0
     */
    protected static $fieldKeys = array (
        self::TYPE_PHPNAME       => array('Id' => 0, 'Ref' => 1, 'Visible' => 2, 'Address1' => 3, 'Address2' => 4, 'Address3' => 5, 'Zipcode' => 6, 'City' => 7, 'CountryId' => 8, 'Email' => 9, 'Phone' => 10, 'Fax' => 11, 'Url' => 12, 'Facebook' => 13, 'Twitter' => 14, 'Pinterest' => 15, 'Google' => 16, 'Youtube' => 17, 'Instagram' => 18, 'Latitude' => 19, 'Longitude' => 20, 'CreatedAt' => 21, 'UpdatedAt' => 22, 'Version' => 23, 'VersionCreatedAt' => 24, 'VersionCreatedBy' => 25, ),
        self::TYPE_STUDLYPHPNAME => array('id' => 0, 'ref' => 1, 'visible' => 2, 'address1' => 3, 'address2' => 4, 'address3' => 5, 'zipcode' => 6, 'city' => 7, 'countryId' => 8, 'email' => 9, 'phone' => 10, 'fax' => 11, 'url' => 12, 'facebook' => 13, 'twitter' => 14, 'pinterest' => 15, 'google' => 16, 'youtube' => 17, 'instagram' => 18, 'latitude' => 19, 'longitude' => 20, 'createdAt' => 21, 'updatedAt' => 22, 'version' => 23, 'versionCreatedAt' => 24, 'versionCreatedBy' => 25, ),
        self::TYPE_COLNAME       => array(AmpSellerTableMap::ID => 0, AmpSellerTableMap::REF => 1, AmpSellerTableMap::VISIBLE => 2, AmpSellerTableMap::ADDRESS1 => 3, AmpSellerTableMap::ADDRESS2 => 4, AmpSellerTableMap::ADDRESS3 => 5, AmpSellerTableMap::ZIPCODE => 6, AmpSellerTableMap::CITY => 7, AmpSellerTableMap::COUNTRY_ID => 8, AmpSellerTableMap::EMAIL => 9, AmpSellerTableMap::PHONE => 10, AmpSellerTableMap::FAX => 11, AmpSellerTableMap::URL => 12, AmpSellerTableMap::FACEBOOK => 13, AmpSellerTableMap::TWITTER => 14, AmpSellerTableMap::PINTEREST => 15, AmpSellerTableMap::GOOGLE => 16, AmpSellerTableMap::YOUTUBE => 17, AmpSellerTableMap::INSTAGRAM => 18, AmpSellerTableMap::LATITUDE => 19, AmpSellerTableMap::LONGITUDE => 20, AmpSellerTableMap::CREATED_AT => 21, AmpSellerTableMap::UPDATED_AT => 22, AmpSellerTableMap::VERSION => 23, AmpSellerTableMap::VERSION_CREATED_AT => 24, AmpSellerTableMap::VERSION_CREATED_BY => 25, ),
        self::TYPE_RAW_COLNAME   => array('ID' => 0, 'REF' => 1, 'VISIBLE' => 2, 'ADDRESS1' => 3, 'ADDRESS2' => 4, 'ADDRESS3' => 5, 'ZIPCODE' => 6, 'CITY' => 7, 'COUNTRY_ID' => 8, 'EMAIL' => 9, 'PHONE' => 10, 'FAX' => 11, 'URL' => 12, 'FACEBOOK' => 13, 'TWITTER' => 14, 'PINTEREST' => 15, 'GOOGLE' => 16, 'YOUTUBE' => 17, 'INSTAGRAM' => 18, 'LATITUDE' => 19, 'LONGITUDE' => 20, 'CREATED_AT' => 21, 'UPDATED_AT' => 22, 'VERSION' => 23, 'VERSION_CREATED_AT' => 24, 'VERSION_CREATED_BY' => 25, ),
        self::TYPE_FIELDNAME     => array('id' => 0, 'ref' => 1, 'visible' => 2, 'address1' => 3, 'address2' => 4, 'address3' => 5, 'zipcode' => 6, 'city' => 7, 'country_id' => 8, 'email' => 9, 'phone' => 10, 'fax' => 11, 'url' => 12, 'facebook' => 13, 'twitter' => 14, 'pinterest' => 15, 'google' => 16, 'youtube' => 17, 'instagram' => 18, 'latitude' => 19, 'longitude' => 20, 'created_at' => 21, 'updated_at' => 22, 'version' => 23, 'version_created_at' => 24, 'version_created_by' => 25, ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, )
    );

    /**
     * Initialize the table attributes and columns
     * Relations are not initialized by this method since they are lazy loaded
     *
     * @return void
     * @throws PropelException
     */
    public function initialize()
    {
        // attributes
        $this->setName('amp_seller');
        $this->setPhpName('AmpSeller');
        $this->setClassName('\\ArtabanMarketplace\\Model\\AmpSeller');
        $this->setPackage('ArtabanMarketplace.Model');
        $this->setUseIdGenerator(true);
        // columns
        $this->addPrimaryKey('ID', 'Id', 'INTEGER', true, null, null);
        $this->addColumn('REF', 'Ref', 'VARCHAR', true, 255, null);
        $this->addColumn('VISIBLE', 'Visible', 'TINYINT', true, null, 0);
        $this->addColumn('ADDRESS1', 'Address1', 'VARCHAR', true, 255, null);
        $this->addColumn('ADDRESS2', 'Address2', 'VARCHAR', false, 255, null);
        $this->addColumn('ADDRESS3', 'Address3', 'VARCHAR', false, 255, null);
        $this->addColumn('ZIPCODE', 'Zipcode', 'VARCHAR', true, 10, null);
        $this->addColumn('CITY', 'City', 'VARCHAR', true, 255, null);
        $this->addForeignKey('COUNTRY_ID', 'CountryId', 'INTEGER', 'country', 'ID', true, null, null);
        $this->addColumn('EMAIL', 'Email', 'VARCHAR', false, 255, null);
        $this->addColumn('PHONE', 'Phone', 'VARCHAR', false, 255, null);
        $this->addColumn('FAX', 'Fax', 'VARCHAR', false, 255, null);
        $this->addColumn('URL', 'Url', 'VARCHAR', false, 255, null);
        $this->addColumn('FACEBOOK', 'Facebook', 'VARCHAR', false, 255, null);
        $this->addColumn('TWITTER', 'Twitter', 'VARCHAR', false, 255, null);
        $this->addColumn('PINTEREST', 'Pinterest', 'VARCHAR', false, 255, null);
        $this->addColumn('GOOGLE', 'Google', 'VARCHAR', false, 255, null);
        $this->addColumn('YOUTUBE', 'Youtube', 'VARCHAR', false, 255, null);
        $this->addColumn('INSTAGRAM', 'Instagram', 'VARCHAR', false, 255, null);
        $this->addColumn('LATITUDE', 'Latitude', 'DECIMAL', false, 16, 0);
        $this->addColumn('LONGITUDE', 'Longitude', 'DECIMAL', false, 16, 0);
        $this->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('VERSION', 'Version', 'INTEGER', false, null, 0);
        $this->addColumn('VERSION_CREATED_AT', 'VersionCreatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('VERSION_CREATED_BY', 'VersionCreatedBy', 'VARCHAR', false, 100, null);
    } // initialize()

    /**
     * Build the RelationMap objects for this table relationships
     */
    public function buildRelations()
    {
        $this->addRelation('Country', '\\Thelia\\Model\\Country', RelationMap::MANY_TO_ONE, array('country_id' => 'id', ), 'CASCADE', null);
        $this->addRelation('AmpSellerAdmin', '\\ArtabanMarketplace\\Model\\AmpSellerAdmin', RelationMap::ONE_TO_MANY, array('id' => 'amp_seller_id', ), 'CASCADE', 'RESTRICT', 'AmpSellerAdmins');
        $this->addRelation('AmpSellerProduct', '\\ArtabanMarketplace\\Model\\AmpSellerProduct', RelationMap::ONE_TO_MANY, array('id' => 'amp_seller_id', ), 'CASCADE', 'RESTRICT', 'AmpSellerProducts');
        $this->addRelation('AmpSellerImage', '\\ArtabanMarketplace\\Model\\AmpSellerImage', RelationMap::ONE_TO_MANY, array('id' => 'amp_seller_id', ), null, null, 'AmpSellerImages');
        $this->addRelation('AmpSellerOrder', '\\ArtabanMarketplace\\Model\\AmpSellerOrder', RelationMap::ONE_TO_MANY, array('id' => 'amp_seller_id', ), null, null, 'AmpSellerOrders');
        $this->addRelation('AmpSellerI18n', '\\ArtabanMarketplace\\Model\\AmpSellerI18n', RelationMap::ONE_TO_MANY, array('id' => 'id', ), 'CASCADE', null, 'AmpSellerI18ns');
        $this->addRelation('AmpSellerVersion', '\\ArtabanMarketplace\\Model\\AmpSellerVersion', RelationMap::ONE_TO_MANY, array('id' => 'id', ), 'CASCADE', null, 'AmpSellerVersions');
    } // buildRelations()

    /**
     *
     * Gets the list of behaviors registered for this table
     *
     * @return array Associative array (name => parameters) of behaviors
     */
    public function getBehaviors()
    {
        return array(
            'timestampable' => array('create_column' => 'created_at', 'update_column' => 'updated_at', ),
            'i18n' => array('i18n_table' => '%TABLE%_i18n', 'i18n_phpname' => '%PHPNAME%I18n', 'i18n_columns' => 'title, description, access', 'locale_column' => 'locale', 'locale_length' => '5', 'default_locale' => '', 'locale_alias' => '', ),
            'versionable' => array('version_column' => 'version', 'version_table' => '', 'log_created_at' => 'true', 'log_created_by' => 'true', 'log_comment' => 'false', 'version_created_at_column' => 'version_created_at', 'version_created_by_column' => 'version_created_by', 'version_comment_column' => 'version_comment', ),
        );
    } // getBehaviors()
    /**
     * Method to invalidate the instance pool of all tables related to amp_seller     * by a foreign key with ON DELETE CASCADE
     */
    public static function clearRelatedInstancePool()
    {
        // Invalidate objects in ".$this->getClassNameFromBuilder($joinedTableTableMapBuilder)." instance pool,
        // since one or more of them may be deleted by ON DELETE CASCADE/SETNULL rule.
                AmpSellerAdminTableMap::clearInstancePool();
                AmpSellerProductTableMap::clearInstancePool();
                AmpSellerI18nTableMap::clearInstancePool();
                AmpSellerVersionTableMap::clearInstancePool();
            }

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     */
    public static function getPrimaryKeyHashFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        // If the PK cannot be derived from the row, return NULL.
        if ($row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)] === null) {
            return null;
        }

        return (string) $row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
    }

    /**
     * Retrieves the primary key from the DB resultset row
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, an array of the primary key columns will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     *
     * @return mixed The primary key of the row
     */
    public static function getPrimaryKeyFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {

            return (int) $row[
                            $indexType == TableMap::TYPE_NUM
                            ? 0 + $offset
                            : self::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)
                        ];
    }

    /**
     * The class that the tableMap will make instances of.
     *
     * If $withPrefix is true, the returned path
     * uses a dot-path notation which is translated into a path
     * relative to a location on the PHP include_path.
     * (e.g. path.to.MyClass -> 'path/to/MyClass.php')
     *
     * @param boolean $withPrefix Whether or not to return the path with the class name
     * @return string path.to.ClassName
     */
    public static function getOMClass($withPrefix = true)
    {
        return $withPrefix ? AmpSellerTableMap::CLASS_DEFAULT : AmpSellerTableMap::OM_CLASS;
    }

    /**
     * Populates an object of the default type or an object that inherit from the default.
     *
     * @param array  $row       row returned by DataFetcher->fetch().
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                 One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     * @return array (AmpSeller object, last column rank)
     */
    public static function populateObject($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        $key = AmpSellerTableMap::getPrimaryKeyHashFromRow($row, $offset, $indexType);
        if (null !== ($obj = AmpSellerTableMap::getInstanceFromPool($key))) {
            // We no longer rehydrate the object, since this can cause data loss.
            // See http://www.propelorm.org/ticket/509
            // $obj->hydrate($row, $offset, true); // rehydrate
            $col = $offset + AmpSellerTableMap::NUM_HYDRATE_COLUMNS;
        } else {
            $cls = AmpSellerTableMap::OM_CLASS;
            $obj = new $cls();
            $col = $obj->hydrate($row, $offset, false, $indexType);
            AmpSellerTableMap::addInstanceToPool($obj, $key);
        }

        return array($obj, $col);
    }

    /**
     * The returned array will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @param DataFetcherInterface $dataFetcher
     * @return array
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function populateObjects(DataFetcherInterface $dataFetcher)
    {
        $results = array();

        // set the class once to avoid overhead in the loop
        $cls = static::getOMClass(false);
        // populate the object(s)
        while ($row = $dataFetcher->fetch()) {
            $key = AmpSellerTableMap::getPrimaryKeyHashFromRow($row, 0, $dataFetcher->getIndexType());
            if (null !== ($obj = AmpSellerTableMap::getInstanceFromPool($key))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj->hydrate($row, 0, true); // rehydrate
                $results[] = $obj;
            } else {
                $obj = new $cls();
                $obj->hydrate($row);
                $results[] = $obj;
                AmpSellerTableMap::addInstanceToPool($obj, $key);
            } // if key exists
        }

        return $results;
    }
    /**
     * Add all the columns needed to create a new object.
     *
     * Note: any columns that were marked with lazyLoad="true" in the
     * XML schema will not be added to the select list and only loaded
     * on demand.
     *
     * @param Criteria $criteria object containing the columns to add.
     * @param string   $alias    optional table alias
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function addSelectColumns(Criteria $criteria, $alias = null)
    {
        if (null === $alias) {
            $criteria->addSelectColumn(AmpSellerTableMap::ID);
            $criteria->addSelectColumn(AmpSellerTableMap::REF);
            $criteria->addSelectColumn(AmpSellerTableMap::VISIBLE);
            $criteria->addSelectColumn(AmpSellerTableMap::ADDRESS1);
            $criteria->addSelectColumn(AmpSellerTableMap::ADDRESS2);
            $criteria->addSelectColumn(AmpSellerTableMap::ADDRESS3);
            $criteria->addSelectColumn(AmpSellerTableMap::ZIPCODE);
            $criteria->addSelectColumn(AmpSellerTableMap::CITY);
            $criteria->addSelectColumn(AmpSellerTableMap::COUNTRY_ID);
            $criteria->addSelectColumn(AmpSellerTableMap::EMAIL);
            $criteria->addSelectColumn(AmpSellerTableMap::PHONE);
            $criteria->addSelectColumn(AmpSellerTableMap::FAX);
            $criteria->addSelectColumn(AmpSellerTableMap::URL);
            $criteria->addSelectColumn(AmpSellerTableMap::FACEBOOK);
            $criteria->addSelectColumn(AmpSellerTableMap::TWITTER);
            $criteria->addSelectColumn(AmpSellerTableMap::PINTEREST);
            $criteria->addSelectColumn(AmpSellerTableMap::GOOGLE);
            $criteria->addSelectColumn(AmpSellerTableMap::YOUTUBE);
            $criteria->addSelectColumn(AmpSellerTableMap::INSTAGRAM);
            $criteria->addSelectColumn(AmpSellerTableMap::LATITUDE);
            $criteria->addSelectColumn(AmpSellerTableMap::LONGITUDE);
            $criteria->addSelectColumn(AmpSellerTableMap::CREATED_AT);
            $criteria->addSelectColumn(AmpSellerTableMap::UPDATED_AT);
            $criteria->addSelectColumn(AmpSellerTableMap::VERSION);
            $criteria->addSelectColumn(AmpSellerTableMap::VERSION_CREATED_AT);
            $criteria->addSelectColumn(AmpSellerTableMap::VERSION_CREATED_BY);
        } else {
            $criteria->addSelectColumn($alias . '.ID');
            $criteria->addSelectColumn($alias . '.REF');
            $criteria->addSelectColumn($alias . '.VISIBLE');
            $criteria->addSelectColumn($alias . '.ADDRESS1');
            $criteria->addSelectColumn($alias . '.ADDRESS2');
            $criteria->addSelectColumn($alias . '.ADDRESS3');
            $criteria->addSelectColumn($alias . '.ZIPCODE');
            $criteria->addSelectColumn($alias . '.CITY');
            $criteria->addSelectColumn($alias . '.COUNTRY_ID');
            $criteria->addSelectColumn($alias . '.EMAIL');
            $criteria->addSelectColumn($alias . '.PHONE');
            $criteria->addSelectColumn($alias . '.FAX');
            $criteria->addSelectColumn($alias . '.URL');
            $criteria->addSelectColumn($alias . '.FACEBOOK');
            $criteria->addSelectColumn($alias . '.TWITTER');
            $criteria->addSelectColumn($alias . '.PINTEREST');
            $criteria->addSelectColumn($alias . '.GOOGLE');
            $criteria->addSelectColumn($alias . '.YOUTUBE');
            $criteria->addSelectColumn($alias . '.INSTAGRAM');
            $criteria->addSelectColumn($alias . '.LATITUDE');
            $criteria->addSelectColumn($alias . '.LONGITUDE');
            $criteria->addSelectColumn($alias . '.CREATED_AT');
            $criteria->addSelectColumn($alias . '.UPDATED_AT');
            $criteria->addSelectColumn($alias . '.VERSION');
            $criteria->addSelectColumn($alias . '.VERSION_CREATED_AT');
            $criteria->addSelectColumn($alias . '.VERSION_CREATED_BY');
        }
    }

    /**
     * Returns the TableMap related to this object.
     * This method is not needed for general use but a specific application could have a need.
     * @return TableMap
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function getTableMap()
    {
        return Propel::getServiceContainer()->getDatabaseMap(AmpSellerTableMap::DATABASE_NAME)->getTable(AmpSellerTableMap::TABLE_NAME);
    }

    /**
     * Add a TableMap instance to the database for this tableMap class.
     */
    public static function buildTableMap()
    {
      $dbMap = Propel::getServiceContainer()->getDatabaseMap(AmpSellerTableMap::DATABASE_NAME);
      if (!$dbMap->hasTable(AmpSellerTableMap::TABLE_NAME)) {
        $dbMap->addTableObject(new AmpSellerTableMap());
      }
    }

    /**
     * Performs a DELETE on the database, given a AmpSeller or Criteria object OR a primary key value.
     *
     * @param mixed               $values Criteria or AmpSeller object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
     public static function doDelete($values, ConnectionInterface $con = null)
     {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerTableMap::DATABASE_NAME);
        }

        if ($values instanceof Criteria) {
            // rename for clarity
            $criteria = $values;
        } elseif ($values instanceof \ArtabanMarketplace\Model\AmpSeller) { // it's a model object
            // create criteria based on pk values
            $criteria = $values->buildPkeyCriteria();
        } else { // it's a primary key, or an array of pks
            $criteria = new Criteria(AmpSellerTableMap::DATABASE_NAME);
            $criteria->add(AmpSellerTableMap::ID, (array) $values, Criteria::IN);
        }

        $query = AmpSellerQuery::create()->mergeWith($criteria);

        if ($values instanceof Criteria) { AmpSellerTableMap::clearInstancePool();
        } elseif (!is_object($values)) { // it's a primary key, or an array of pks
            foreach ((array) $values as $singleval) { AmpSellerTableMap::removeInstanceFromPool($singleval);
            }
        }

        return $query->delete($con);
    }

    /**
     * Deletes all rows from the amp_seller table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public static function doDeleteAll(ConnectionInterface $con = null)
    {
        return AmpSellerQuery::create()->doDeleteAll($con);
    }

    /**
     * Performs an INSERT on the database, given a AmpSeller or Criteria object.
     *
     * @param mixed               $criteria Criteria or AmpSeller object containing data that is used to create the INSERT statement.
     * @param ConnectionInterface $con the ConnectionInterface connection to use
     * @return mixed           The new primary key.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function doInsert($criteria, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerTableMap::DATABASE_NAME);
        }

        if ($criteria instanceof Criteria) {
            $criteria = clone $criteria; // rename for clarity
        } else {
            $criteria = $criteria->buildCriteria(); // build Criteria from AmpSeller object
        }

        if ($criteria->containsKey(AmpSellerTableMap::ID) && $criteria->keyContainsValue(AmpSellerTableMap::ID) ) {
            throw new PropelException('Cannot insert a value for auto-increment primary key ('.AmpSellerTableMap::ID.')');
        }


        // Set the correct dbName
        $query = AmpSellerQuery::create()->mergeWith($criteria);

        try {
            // use transaction because $criteria could contain info
            // for more than one table (I guess, conceivably)
            $con->beginTransaction();
            $pk = $query->doInsert($con);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }

        return $pk;
    }

} // AmpSellerTableMap
// This is the static code needed to register the TableMap for this table with the main Propel class.
//
AmpSellerTableMap::buildTableMap();
